diff -ur nagiosplug/plugins/check_http.c nagiosplug_proxy/plugins/check_http.c
--- nagiosplug/plugins/check_http.c	Thu Nov 14 05:25:44 2002
+++ nagiosplug_proxy/plugins/check_http.c	Wed Nov 20 14:58:08 2002
@@ -270,6 +270,7 @@
 process_arguments (int argc, char **argv)
 {
 	int c = 1;
+	char *proxyurl2 = NULL;
 
 #ifdef HAVE_GETOPT_H
 	int option_index = 0;
@@ -467,10 +468,24 @@
 		http_method = strscpy (http_method, "GET");
 
 	if (server_url == NULL) {
-		server_url = strscpy (NULL, "/");
-		server_url_length = strlen(HTTP_URL);
+		if((!(proxyurl2 = getenv("http_proxy"))) && (!(proxyurl2 = getenv("HTTP_PROXY")))) {
+//	                if (proxyurl2 && proxyurl2[0] && strcmp(proxyurl2, "none")) 
+			server_url = strscpy (NULL, "/");
+			server_url_length = strlen(HTTP_URL);
+			}
+		else {
+			if (strncasecmp(host_name, "http://", 7)) {
+				asprintf(&server_url, "http://%s", host_name);
+				server_url_length = strlen(server_url);
+			} else {
+				server_url = host_name;
+				server_url_length = strlen(HTTP_URL);
+			}
+		//server_url = strscpy (NULL, "/");
+		//server_url_length = strlen(server_url);
+		}
 	}
-
+	
 	return TRUE;
 }
 
diff -ur nagiosplug/plugins/netutils.c nagiosplug_proxy/plugins/netutils.c
--- nagiosplug/plugins/netutils.c	Thu Feb 28 06:42:59 2002
+++ nagiosplug_proxy/plugins/netutils.c	Wed Nov 20 14:58:20 2002
@@ -247,7 +247,6 @@
 	return result;
 }
 
-
 /* opens a connection to a remote host/udp port */
 int
 my_udp_connect (char *host_name, int port, int *sd)
@@ -260,6 +259,10 @@
 	return result;
 }
 
+char *proxyurl = NULL;
+unsigned long proxyip = 0;
+//unsigned char *proxyport;
+int proxyport;
 
 /* opens a tcp or udp connection to a remote host */
 int
@@ -269,10 +272,83 @@
 	struct hostent *hp;
 	struct protoent *ptrp;
 	int result;
-
 	bzero ((char *) &servaddr, sizeof (servaddr));
 	servaddr.sin_family = AF_INET;
+//	servaddr.sin_port = htons (port);
+
+	
+
+	/* proxy check */
+	if (!proxyip) {
+          if (!proxyurl)
+            if (!(proxyurl = getenv("http_proxy")))
+            	proxyurl = getenv("HTTP_PROXY");
+            if (proxyurl && proxyurl[0] && strcmp(proxyurl, "none")) {
+
+		if( (proxyurl  = getenv( "http_proxy" )) != NULL && *proxyurl  )
+		{
+	    
+		if (!(strncasecmp(proxyurl, "http://", 7))) {
+			proxyurl = proxyurl + 7; 
+ 		}
+
+		while (*proxyurl && (*proxyurl == ':' && *proxyurl == '/' ) ) {
+			proxyurl++;
+		}
+
+		if (*proxyurl)
+		{	
+			char *psz_port = proxyurl;
+	
+            		/* Skip the hostname part */
+            		while( *psz_port && *psz_port != ':' && *psz_port != '/' )
+            		{
+                		psz_port++;
+            		}
+
+          		  /* Found a port name */
+            		if( *psz_port )
+            		{
+                		char * psz_junk;
+
+                		/* Replace ':' with '\0' */
+                		*psz_port = '\0';
+                		psz_port++;
+
+                		psz_junk = psz_port;
+                	while( *psz_junk && *psz_junk != '/' )
+                	{
+                   		 psz_junk++;
+                	}
+
+                	if( *psz_junk )
+                	{
+                    		*psz_junk = '\0';
+                	}
+
+                	if( *psz_port != '\0' )
+                	{
+                    		proxyport = atoi( psz_port );
+                	}
+            	}
+	    }
+	    else
+	    {
+		printf("http_proxy environement not valid ! (http_proxy=http://proxy.domain.com:port/");
+            } 
+	  }
+
+	  host_name = proxyurl;
+	  port = proxyport;
+        }
+                
+        else
+              proxyip = INADDR_NONE;
+        }
+
 	servaddr.sin_port = htons (port);
+
+
 
 	/* try to bypass using a DNS lookup if this is just an IP address */
 	if (!my_inet_aton (host_name, &servaddr.sin_addr)) {
